<?php
namespace Teknisa\CRM\Controller;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\CRM\Controller\TeknisaCrud;

class crm00001003ResultadoEvolucaoController extends TeknisaCrud {
    protected $dataSourceName = 'crm_resultevol_temp';
    
    public function setResultEvol(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            foreach ($request->getDataSet()->getRows() as &$row) {
                if (array_key_exists('NRSEQRESULEVOL', $row)) {
                    if ($row['__is_new']) {
                        $row['NRSEQRESULEVOL'] = NovoCodigo::geraCodigo($row['NRORG'], "CRM_RESULTEVOL", 1, 10, true, true);
                    }
                } else {
                    $row['NRSEQRESULEVOL'] = NovoCodigo::geraCodigo($row['NRORG'], "CRM_RESULTEVOL", 1, 10, true, true);
                }
            
            }
            $row['IDGANHAPERDE'] = empty($row['IDGANHAPERDE']) ? 'PERDE' : $row['IDGANHAPERDE'];
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}