<?php
namespace Teknisa\CRM\Controller;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Model\Util\NovoCodigo;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\CRM\Controller\TeknisaCrud;

class crm00150000TipoContatoController extends TeknisaCrud {
    protected $dataSourceName = 'tipocont';
    
    public function setTipoCont(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            foreach ($request->getDataSet()->getRows() as &$row) {
                if (array_key_exists('CDTIPOCONT', $row)) {
                    if ($row['__is_new']) {
                        $row['CDTIPOCONT'] = NovoCodigo::geraCodigo($row['NRORG'], "TIPOCONT", 1, 2);
                    }
                } else {
                    $row['CDTIPOCONT'] = NovoCodigo::geraCodigo($row['NRORG'], "TIPOCONT", 1, 2);
                }
            
            }
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}