<?php

namespace Teknisa\CRM\Service;

class AgrupamentoParceiroService {
    
    protected $agrupamentoParceiroFactory;
    
    public function __construct($agrupamentoParceiroFactory) {
        
        $this->agrupamentoParceiroFactory = $agrupamentoParceiroFactory;
    }
    

    public function executeDeleteGroup($row){
        $paramsQuery = array (
            "NRAGRPARC"        => $row['NRAGRPARC'],
            "CRM_NRORGTRAB"    => $row['CRM_NRORGTRAB'],
            "NRORG"            => $row['NRORG']
        );
        
        $this->agrupamentoParceiroFactory->queryDeleteGroup($paramsQuery);
    }
    
    public function verifyGroup($row){
        $response = array();
        
        $paramsQuery = array (
            "NRPARCNEGOCIO_REL" => $row['NRPARCNEGOCIO'],
            "CRM_NRORGTRAB"     => $row['CRM_NRORGTRAB'],
            "NRORG"             => $row['NRORG']
        );
        
        $response = $this->agrupamentoParceiroFactory->verifyGroup($paramsQuery);
        
        if(!empty($response)) {
            return array($response, 'PPR');         //Parceiro-Pai Relacionado
        } else {
            $paramsQueryRel = array (
                "NRPARCNEGOCIO_REL"  => $row['NRPARCNEGOCIO_REL'],
                "CRM_NRORGTRAB"      => $row['CRM_NRORGTRAB'],
                "NRORG"              => $row['NRORG']
            );
            
            $response = $this->agrupamentoParceiroFactory->verifyGroup($paramsQueryRel);
            
            if(!empty($response)) {
                return array($response, 'PFR');     //Parceiro-Filgo Relacionado
            } else {
                return false;                          //Retorna falso se caso todas as verificações não acharem uma relação
            }
        }
        
    }

    public function verifyGroupRel($row){
        $response = array();
        
        $paramsQuery = array (
            "NRPARCNEGOCIO_REL" => $row['NRPARCNEGOCIO'],
            "CRM_NRORGTRAB"     => $row['CRM_NRORGTRAB'],
            "NRORG"             => $row['NRORG']
        );
        
        return $this->agrupamentoParceiroFactory->verifyGroup($paramsQuery);
    }
    
    public function agrupamentoEvolSave($row){
        $txtevolcont = empty($row['TXEVOLCONT']) ? $row['TXEVOLCONT'] : 'Evolução de realizada a partir da conversão do Parceiro Relacionado Pai.';
        
        
        $paramsQuery = array (
            "NRCONTATO"         => $row['NRCONTATO'],
            "DTHREVOLCONT"      => empty($row['DTHREVOLCONT']) ? $row['DTHREVOLCONT'] : $row['DTINCLUSAO'],
            "CDTIPOCONT"        => empty($row['CDTIPOCONT']) ? $row['CDTIPOCONT'] : null,
            "IDSENEVOCONT"      => empty($row['IDSENEVOCONT']) ? $row['IDSENEVOCONT'] : 'S',
            "CDOPEREVOL"        => empty($row['CDOPEREVOL']) ? $row['CDOPEREVOL'] : $row['CDOPERADOR'],
            "CDMOTIEVOCON"      => empty($row['CDMOTIEVOCON']) ? $row['CDMOTIEVOCON'] : null,
            "NRORG"             => $row['NRORG'],
            "CRM_NRORGTRAB"     => $row['CRM_NRORGTRAB'],
            "TXEVOLCONT"        => $txtevolcont,
            "NRSEQRESULEVOL"    => empty($row['NRSEQRESULEVOL']) ? $row['NRSEQRESULEVOL'] : null,
            "NRSEQEVOLCONT"     => $row['NRSEQEVOLCONT'],
            "NRSEQCONTATO"      => $row['NRSEQCONTATO'],
            "CDFILIAL"          => isset($row['CDFILIAL']) ? $row['CDFILIAL'] : null
        );
        
        $this->agrupamentoParceiroFactory->agrupamentoEvolSave($paramsQuery);
        
    }
    
    public function verifyParcGroupRel($row){
        $resp = array();
        
        $paramsQuery = array (
            "NRPARCNEGOCIO"     => $row['NRPARCNEGOCIO'],
            "CRM_NRORGTRAB"     => $row['CRM_NRORGTRAB'],
            "NRORG"             => $row['NRORG']
        );
        
        $resp[] = $this->agrupamentoParceiroFactory->verifyParcGroupRel($paramsQuery);
        
        $paramsQuery = array (
            "NRPARCNEGOCIO"     => $row['NRPARCNEGOCIO'],
            "CRM_NRORGTRAB"     => $row['CRM_NRORGTRAB'],
            "NRORG"             => $row['NRORG']
        );
        
        $resp[] = $this->agrupamentoParceiroFactory->searchParcnegocio($paramsQuery);
        
        return $resp;
    }
    
    public function searchNrContato($row){
        $paramsQuery = array (
            "NRPARCNEGOCIO"     => $row['NRPARCNEGOCIO'],
            "NRORG"             => $row['NRORG']
        );
        
        return $this->agrupamentoParceiroFactory->searchNrContato($paramsQuery);
        
    }
    
    public function getRelationshipPartnerStatus($row){
        try{
            $paramsQuery = array (
                "NRPARCNEGOCIO"     => $row['NRPARCNEGOCIO'],
                "CRM_NRORGTRAB"     => $row['CRM_NRORGTRAB'],
                "NRORG"             => $row['NRORG']
            );
            
            $this->agrupamentoParceiroFactory->getRelationshipPartnerStatus($paramsQuery);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
    public function setRelationshipPartnerStatus($row, $status){
        try{
            $paramsQuery = array (
                "NRPARCNEGOCIO"     => $row['NRPARCNEGOCIO'],
                "CRM_NRORGTRAB"     => $row['CRM_NRORGTRAB'],
                "NRORG"             => $row['NRORG'],
                "STATUSPARC"        => $status
            );
            
            $this->agrupamentoParceiroFactory->setRelationshipPartnerStatus($paramsQuery);
        } catch(\Exception $e) {
            throw $e;
        }
    }
    
}