/*
      8380_SUPSTPS_DUPLICA_PRECO_OBJETIVO.SQL

      P_IDDUPLICA - Tipo de duplicao:
      1 - Planilha Corrente (posicionada na tela)
      2 - Planilhas com aquela validade
*/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DUPLICA_PRECO_OBJETIVO'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)

   DROP PROCEDURE DUPLICA_PRECO_OBJETIVO;
GO
CREATE PROCEDURE DUPLICA_PRECO_OBJETIVO
   @P_CDFILIAL     VARCHAR(4),
   @P_CDREGIAO     VARCHAR(3),
   @P_NRPRECOBJET  VARCHAR(10),
   @P_IDDUPLICA    VARCHAR(1),
   @P_DTINIVALPLAN DATETIME,
   @P_DTFINVALPLAN DATETIME,
   @P_LISTAFILI    VARCHAR(2000),
   @P_REAJUSTE     NUMERIC(10,5),
   @P_DTNOVINIVAL  DATETIME,
   @P_DTNOVFINVAL  DATETIME

AS

   DECLARE @V_CDFILIAL        VARCHAR(4);
   DECLARE @V_CDREGIAO        VARCHAR(3);
   DECLARE @V_CDPRODUTO       VARCHAR(10);
   DECLARE @V_VRPRECOBJETIVO  NUMERIC(15, 5);

   DECLARE @V_NOVONRPRECOBJET VARCHAR(20);
   DECLARE @V_NRPRECOBJETORIG VARCHAR(10);
   DECLARE @V_CDFILIALORIG    VARCHAR(4);

   DECLARE @V_AUX        VARCHAR(50);

BEGIN

  DECLARE C_FILIPLANPRECO CURSOR FOR
      SELECT CDFILIAL, CDREGIAO
        FROM FILIAL
       WHERE (CHARINDEX(CDFILIAL, @P_LISTAFILI) > 0)  or ( 'T' = @P_LISTAFILI)
       ORDER BY CDFILIAL;

  OPEN C_FILIPLANPRECO;
  FETCH NEXT FROM C_FILIPLANPRECO INTO @V_CDFILIAL,
                                       @V_CDREGIAO;

  WHILE (@@FETCH_STATUS = 0)
  BEGIN

    SET @V_AUX = 'PRECOBJETIVO'+@V_CDFILIAL;
    EXEC NOVO_CODIGO @V_AUX, @P_SEQUENCIAL = @V_NOVONRPRECOBJET OUTPUT, @P_QTDE = 1;
    SET @V_NOVONRPRECOBJET = SUBSTRING(@V_NOVONRPRECOBJET,11,10);

    INSERT INTO PRECOBJETIVO
       (CDFILIAL,
        NRPRECOBJET,
        DTPRECOBJET,
        DTINIVALOBJET,
        DTFINVALOBJET)
    VALUES
       (@V_CDFILIAL,
        @V_NOVONRPRECOBJET,
        CONVERT(DATETIME, GETDATE(), 103),
        @P_DTNOVINIVAL,
        @P_DTNOVFINVAL);

    DECLARE C_PRECOJETIVO CURSOR FOR
                          SELECT CDPRODUTO, ((MIN(VRPRECOBJETIVO)+(MIN(VRPRECOBJETIVO) * @P_REAJUSTE) / 100)) VRPRECOBJETIVO
                            FROM ITEMPRECOJETIVO
                           WHERE ((@P_IDDUPLICA = '1' AND NRPRECOBJET = @P_NRPRECOBJET) OR
                                  (@P_IDDUPLICA = '2'  AND DTINIVALITMOBJ >= @P_DTINIVALPLAN AND DTFINVALITMOBJ <= @P_DTFINVALPLAN))
                           GROUP BY CDPRODUTO
                           ORDER BY VRPRECOBJETIVO;
    OPEN C_PRECOJETIVO;
    FETCH NEXT FROM C_PRECOJETIVO INTO @V_CDPRODUTO,
                                       @V_VRPRECOBJETIVO;
    WHILE (@@FETCH_STATUS = 0)
    BEGIN

       SELECT @V_NRPRECOBJETORIG = MAX(NRPRECOBJET), @V_CDFILIALORIG = MAX(CDFILIAL)
         FROM ITEMPRECOJETIVO
        WHERE CDPRODUTO = @V_CDPRODUTO
          AND VRPRECOBJETIVO = ((@V_VRPRECOBJETIVO * 100) / (100 + @P_REAJUSTE));

       INSERT INTO ITEMPRECOJETIVO
              (CDFILIAL,
               NRPRECOBJET,
               CDREGIAO,
               CDPRODUTO,
               DTINIVALITMOBJ,
               DTFINVALITMOBJ,
               VRPRECOBJETIVO,
               NRPRECOBJETORIG,
               CDFILIALORIG)
           VALUES
              (@V_CDFILIAL,
               @V_NOVONRPRECOBJET,
               @V_CDREGIAO,
               @V_CDPRODUTO,
               @P_DTNOVINIVAL,
               @P_DTNOVFINVAL,
               @V_VRPRECOBJETIVO,
               @V_NRPRECOBJETORIG,
               @V_CDFILIALORIG);

    FETCH NEXT FROM C_PRECOJETIVO INTO @V_CDPRODUTO,
                                       @V_VRPRECOBJETIVO;
    END;
    CLOSE C_PRECOJETIVO;
    DEALLOCATE C_PRECOJETIVO;

  FETCH NEXT FROM C_FILIPLANPRECO INTO @V_CDFILIAL,
                                       @V_CDREGIAO;
  END;
  CLOSE C_FILIPLANPRECO;
  DEALLOCATE C_FILIPLANPRECO;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DUPLICA_PRECO_OBJETIVO','5.60.XXX';
GO

