function agrupamentoParceiroController(ScreenService, ValidationEngine, templateManager, Utilities, wizardEngine, ZHPromise, restEngine, Operador_Repository, General, CRM_Utilities, Messages) {
    
    var self = this;
    
    
    this.widgetOnEnter = function(widget, fieldsToApply) {
        var filterRow = {};
        filterRow.CDOPERRESPONSAVEL = [templateManager.LOGGEDOPERATOR.CDOPERADOR];
        filterRow.IDATIVO = 'S';
        
        CRM_Utilities.openFilterOnEnter(widget, filterRow, fieldsToApply);
    };
    

    this.showCantEditMessage = function() {
        var message = `Ação bloqueada!<br>
             Somente o operador responsável pelo lead e seus assistentes podem
             editá-lo/evoluí-lo.`;
             
        ScreenService.showMessage(message);
    };
    
    this.save = function() {
        var widget = templateManager.container.getWidget('agrupamentoGrid');
        var currentRow = widget.currentRow;
        var evolWidget = templateManager.container.getWidget('evolucao');
        var evolCurrentRow = evolWidget.currentRow;
        
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        
        if(evolWidget.isValid()) {
            this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
                if(canEdit) {
                    if(widget.isValid()) {
                        
                        ScreenService.confirmMessage("A evolução será criada para todos os parceiros relacionados. Deseja continuar?", "question", () => {
                            currentRow.NRORG = getLocalVar('CRM_NRORG');
                            currentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                            currentRow.CDOPERINCLUSAO = templateManager.LOGGEDOPERATOR.CDOPERADOR;
                            currentRow.NRORGINCLUSAO = getLocalVar('CRM_NRORG');
                            currentRow.CDOPERULTATU = templateManager.LOGGEDOPERATOR.CDOPERADOR;
                            currentRow.NRORGULTATU = getLocalVar('CRM_NRORG');
                            
                            var parcnegocioRows = currentRow.NRPARCNEGOCIO_REL;
                            var rows = [];
                            
                            parcnegocioRows.forEach(function(parcnegocio, parcnegociotIndex){
                                rows.push(this.setParcnegocioValues(widget, parcnegociotIndex));
                            }.bind(this)); 
                            
                            General.callRestEngine("product#/agrupamentoParceiros/save", "DataSet", rows).then(function(response){
                                if(response.dataset && response.dataset.error) {
                                    ScreenService.showMessage(response.dataset.error, 'ERROR');
                                }
                                if(response.dataset && (response.dataset.PPR || response.dataset.PFR)) {
                                    var dataset = response.dataset;
                                    
                                    ScreenService.notificationMessage("Ocorreram erros na adição dos registros, verifique o popup de mensagens!", "alert");
                                    openPopupMensagens(dataset.msg);
                                }
                                
                                if(!Util.isEmptyOrBlank(response.dataset.PARCS)) {
                                    response.dataset.PARCS.forEach(function(parcnegocio, index) {
                                        evolCurrentRow.NRPARCNEGOCIO = parcnegocio;
                                            General.callRestEngine("product#/agrupamentoEvolSave", "Row", evolCurrentRow).then(function(resp){
                                                if(resp.dataset && resp.dataset.error) {
                                                    ScreenService.showMessage(resp.dataset.error, 'ERROR');
                                                } else if(resp.error) {
                                                    ScreenService.showMessage(resp.error, 'ERROR');
                                                }
                                            });
                                    }.bind(this));
                                }
                                
                                ScreenService.closeSwipe();
                                widget.list();
                                widget.reload();
                            }.bind(this));
                        });
                    }
                } else {
                    this.showMessageCantEditParc();
                }
            });
        }
    };
    
    this.newRow = function() {
        var widget = templateManager.container.getActiveWidget();
        
        General.widgetNewRow(widget);
    };
    
    this.deleteRow = function() {
        var widget = templateManager.container.getWidget('agrupamentoGrid');
        var evolWidget = templateManager.container.getWidget('evolucao');
        
        var nrParcNegocio = widget.currentRow.NRPARCNEGOCIO;
        
        this.checkIfCanEditOrEvolParc(nrParcNegocio).then(canEdit => {
            if(canEdit) {
                if(evolWidget.isValid()) {
                    General.deleteCrud(widget).then(() => {
                        General.callRestEngine("product#/agrupamentoEvolSave", "Row", evolWidget.currentRow).then(function(resp){
                            if(resp.dataset && resp.dataset.error) {
                                ScreenService.showMessage(resp.dataset.error, 'ERROR');
                            } else if(resp.error) {
                                ScreenService.showMessage(resp.error, 'ERROR');
                            } else {
                                ScreenService.closeSwipe();
                            }
                        });
                    });
                }
            } else {
                this.showMessageCantEditParc();
            }
        });
    };
    
    this.cancelForm = function() {
        var widget = templateManager.container.getWidget('agrupamentoGrid');
        var widgetEvol = templateManager.container.getWidget('evolucao');
        
        General.widgetCancelForm(widget);
        General.widgetCancelForm(widgetEvol);
    };
    
    this.setParcnegocioValues = function(widget, parcnegocioIndex){
        var currentRow = angular.copy(widget.currentRow);
        var agrupamentoWidgetCurrentRow = this.getAgrupamentoWidgetCurrentRow();
        var loggedOperatorInfos = CRM_Utilities.getLoggedOperatorInfos();
        
        currentRow.NRPARCNEGOCIO = currentRow.NRPARCNEGOCIO;  
        currentRow.NRPARCNEGOCIO_REL = currentRow.NRPARCNEGOCIO_REL[parcnegocioIndex];
        currentRow.NMPRINCIPALPARCREL = currentRow.NMPRINCIPALPARCREL[parcnegocioIndex];
        currentRow.NRORG = currentRow.NRORG;
        currentRow.CRM_NRORGTRAB = currentRow.CRM_NRORGTRAB;
        currentRow.IDATIVO = agrupamentoWidgetCurrentRow.IDATIVO;
        currentRow.CDOPERINCLUSAO = agrupamentoWidgetCurrentRow.CDOPERINCLUSAO;
        currentRow.NRORGINCLUSAO = agrupamentoWidgetCurrentRow.NRORGINCLUSAO;
        currentRow.CDOPERULTATU = agrupamentoWidgetCurrentRow.CDOPERULTATU;
        currentRow.NRORGULTATU = agrupamentoWidgetCurrentRow.NRORGULTATU;
        currentRow.DTINCLUSAO = loggedOperatorInfos.DTINCLUSAO;
        currentRow.DTULTATU = agrupamentoWidgetCurrentRow.DTULTATU;
        
        return currentRow;
    };
    
    this.getAgrupamentoWidgetCurrentRow = function(){
        var agrupamentotWidget = templateManager.container.getWidget("agrupamentoGrid");
        
        return agrupamentotWidget.currentRow;
        
    };
    
    var openPopupMensagens = function(msg) {
        var widgetMensagens = templateManager.container.getWidget('messagesImportacaoAgrupamento');
        widgetMensagens.dataSource.data = msg;
        ScreenService.openPopup(widgetMensagens);
    };
    
    this.popupMessagesVoltar = function() {
        ScreenService.closePopup();
        templateManager.container.getWidget('agrupamentoGrid').activate();
    };
    
    this.showMessageCantEditParc = function() {
        var message = `Ação bloqueada!<br>
             Somente o operador responsável pelo prospect e seus assistentes podem
             editá-lo/evoluí-lo.`;
             
        ScreenService.showMessage(message);
    };
    
    this.checkIfCanEditOrEvolParc = function(nrParcNegocio) {
        var restRow = {
            NRPARCNEGOCIO: nrParcNegocio,
            CRM_NRORGTRAB: getLocalVar('CRM_NRORGTRABALHO')
        };
        
        var params = {
            requestType: 'Row',
            row: restRow
        };
        
        return restEngine.post('/checkIfCanEditOrEvolParc', params).then(response => {
            return response.dataset.DADOS.CAN_EDIT;
        }).catch(() => {
            return false;
        });
    };
    
    this.openEvolTab = function() {
        var widget = templateManager.container.getActiveWidget();
        var currentRow = widget.currentRow;
        var evolWidget = templateManager.container.getWidget('evolucao');
        
        var loggedOperatorInfos = templateManager.LOGGEDOPERATOR;
        
        if(widget.isValid()) {
            ScreenService.closeSwipe().then(() => {
                widget.list();
                evolWidget.actions.find(x => x.name == 'SAVE').isVisible = true;
                evolWidget.actions.find(x => x.name == 'confirmDeleteParc').isVisible = false;
                evolWidget.activate();
                evolWidget.newRow();
                
                var evolCurrentRow = evolWidget.currentRow;
                evolCurrentRow.NRPARCNEGOCIO = currentRow.NRPARCNEGOCIO_REL;
                evolCurrentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                evolCurrentRow.NMOPERADOREVOL = loggedOperatorInfos.NMOPERADOR;
                evolCurrentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                evolCurrentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
                evolCurrentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
                evolCurrentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                evolCurrentRow.DTHREVOLCONT = (currentRow.DTHREVOLCONT)? currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
                evolCurrentRow.TXEVOLCONT = "Realizado o agrupamento de parceiro com o parceiro " + currentRow.NMPRINCIPALPARC;
                
                evolWidget.redraw();
                
                ScreenService.openSwipe(evolWidget);
                
            });
        }
    };
    
    this.openEvolRemoveTab = function() {
        var widget = templateManager.container.getActiveWidget();
        var currentRow = widget.currentRow;
        var evolWidget = templateManager.container.getWidget('evolucao');
        
        var loggedOperatorInfos = templateManager.LOGGEDOPERATOR;
        
        if(widget.isValid()) {
            ScreenService.closeSwipe().then(() => {
                widget.list();
                evolWidget.actions.find(x => x.name == 'SAVE').isVisible = false;
                evolWidget.actions.find(x => x.name == 'confirmDeleteParc').isVisible = true;
                evolWidget.activate();
                evolWidget.newRow();
                
                var evolCurrentRow = evolWidget.currentRow;
                evolCurrentRow.NRPARCNEGOCIO = currentRow.NRPARCNEGOCIO_REL;
                evolCurrentRow.NMOPERADOR = loggedOperatorInfos.NMOPERADOR;
                evolCurrentRow.NMOPERADOREVOL = loggedOperatorInfos.NMOPERADOR;
                evolCurrentRow.CDOPEREVOL = loggedOperatorInfos.CDOPERADOR;
                evolCurrentRow.CDOPERADOR = loggedOperatorInfos.CDOPERADOR;
                evolCurrentRow.NRORG = getLocalVar('CRM_NRORGTRAB');
                evolCurrentRow.CRM_NRORGTRAB = getLocalVar('CRM_NRORGTRABALHO');
                evolCurrentRow.DTHREVOLCONT = (currentRow.DTHREVOLCONT)? currentRow.DTHREVOLCONT : moment(new Date()).format('DD/MM/YYYY HH:mm');
                evolCurrentRow.TXEVOLCONT = "Retirado o agrupamento de parceiro com o parceiro " + currentRow.NMPRINCIPALPARC;
                
                evolWidget.redraw();
                
                ScreenService.openSwipe(evolWidget);
                
            });
        }
    };
    
    this.popupMensagensVoltar = function() {
        var widget = templateManager.container.getWidget('agrupamentoGrid');
        
        ScreenService.closePopup();
        General.cancelForm(widget);
        widget.activate();
        widget.list();
        
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('agrupamentoParceiroController', agrupamentoParceiroController);
});