var UtilDevTools = function(){};

UtilDevTools.getZeedhiTypes = function(){
    var zeedhiTypes = ['__metadata', 'widgets', 'fields'];
    if(!window.inCustomizationMode){
        zeedhiTypes.push('actions');
    }
    return zeedhiTypes;
};

UtilDevTools.getIgnoredZeedhiTypes = function(){
    var zeedhiTypes = [];
    if(window.inCustomizationMode){
        zeedhiTypes.push('actions');
        zeedhiTypes.push('__original');
    }
    return zeedhiTypes;
};

UtilDevTools.getZeedhiTypesSubitems = function(){
    var subitemsPropertiesMap = {
        'container': ['widgets'],
        'widget': ['widgets', 'fields'],
        'field': [],
        'action': [],
        'groupMenu': [],
        'menu': []
    };

    if(!window.inCustomizationMode){
        subitemsPropertiesMap.widget.push('actions');
    }
    return subitemsPropertiesMap;
};


UtilDevTools.buildInDeveloperModeMethod = function(method){
    return function buildInDeveloperModeMethod(){
        var obj = this,
            args = arguments;

        if(window.inDeveloperMode || window.inCustomizationMode){
            method.apply(obj, args);
        }
    };
};

UtilDevTools.buildInCustomizationModeMethod = function(method){
    return function buildInCustomizationModeMethod(){
        var obj = this,
            args = arguments;

        if(window.inCustomizationMode){
            method.apply(obj, args);
        }
    };
};

UtilDevTools.buildDevToolsWindowMethod = function(method){
    return function buildDevToolsWindowMethod(){
        var obj = this,
            args = arguments,
            DevToolsWindow = window.parent ? window : null;

        if(window.parent == window){
            DevToolsWindow = window.opener ? window : null;
        }

        if(DevToolsWindow){
            method.apply(obj, args);
        }
    };
};

UtilDevTools.buildMainWindowMethod = function(method){
    return function buildMainWindowMethod(){
        var obj = this,
            args = arguments,
            MainWindow = window.parent ? window.parent : window;

        if(window.parent == window){
            MainWindow = window.opener ? window.opener : window;
        }
        if(MainWindow === window){
            method.apply(obj, args);
        }
    };
};

UtilDevTools.getDevToolsWindow = function(){
    var DevToolsWindow;
    if(window.parent == window){
        DevToolsWindow = window.opener ? window : null;
    } else {
        DevToolsWindow = window.parent ? window : null;
    }
    return DevToolsWindow;
};

UtilDevTools.getMainWindow = function(){
    var MainWindow;
    if(window.parent == window){
        MainWindow = window.opener ? window.opener : window;
    } else {
        MainWindow = window.parent ? window.parent : window;
    }
    return MainWindow;
};